#include <basic.h>
#include <btron/device.h>

// ʲ$(BD)/include/driver/pcat/sys.h 
//  (AsmιԤѥǤʤΤǤȤꤢ)
#define _DRIVER_PCAT_SYS_H_
#define INTVEC(irq)     ( (irq) ^ 0x78 )        /* CPU γ٥ֹ */

typedef enum {
        IRQ0    = 0,
        IRQ1    = 1,
        IRQ2    = 2,
        IRQ3    = 3,
        IRQ4    = 4,
        IRQ5    = 5,
        IRQ6    = 6,
        IRQ7    = 7,
        IRQ8    = 8,
        IRQ9    = 9,
        IRQ10   = 10,
        IRQ11   = 11,
        IRQ12   = 12,
        IRQ13   = 13,
        IRQ14   = 14,
        IRQ15   = 15
} IRQ;

typedef enum {
        IV_OTIM = INTVEC(IRQ0),         /* OSѥ󥿡Х륿 */
        IV_KB   = INTVEC(IRQ1),         /* ܡ */
        IV_FD   = INTVEC(IRQ6),         /* եåԡǥɥ饤 */
        IV_RTC  = INTVEC(IRQ8),         /* ꥢ륿९å */
        IV_FPU  = INTVEC(IRQ13)         /* ư黻˥å */
} IntVector;

#include <device/rs.h>
#include "krs232c.h"

W krs_open(int port)
{
  TC dev[4] = {L""};
  dev[2] += (port & 0x000f);
  return (opn_dev(dev, D_UPDATE|D_EXCL|D_NOWAIT, NULL));
}

W krs_close(W dd)
{
  return (cls_dev(dd, 0, NULL));
}

W krs_init(W dd, int speed, int length, int parity, int stop)
{
  W dummy;
  RsMode param;
  param.parity = parity;
  param.datalen = length;
  param.stopbits = stop;
  param.baud = speed;

  //  RsFlow ⥻åȤ٤ ޤưʤäľȡ
  
  return (wri_dev(dd, DN_RSMODE, (B*)&param, sizeof(param), &dummy, NULL));
}

W krs_chkbuf(W dd)
{
  W asize, err;
  err = rea_dev(dd, 0, NULL, 0, &asize, NULL);
  if (err < 0){
    return err;
  }
  return asize;
}

W krs_getc(W dd)
{
  B c;
  W dummy, ret;
  ret = rea_dev(dd, 0, &c, 1, &dummy, NULL);
  if (ret >= 0){
    ret = c & 0x00ff;
  }
  return ret;
}

W krs_putc(W dd, B c)
{
  W dummy;
  return (wri_dev(dd, 0, &c, 1, &dummy, NULL));
}

W krs_flush(W dd)
{
  while (krs_chkbuf(dd) != 0){
    krs_getc(dd);
  }
  return 0;
}

W krs_getc2(W dd)
{
  while (krs_chkbuf(dd) == 0){
    ;
  }
  return (krs_getc(dd));
}

