#include <basic.h>
#include <tcode.h>
#include "subc.h"
#include "message.h"
#include "cerror.h"

extern OutSider grovalFunc;

void CMessage::runtime_mes(TC *str, ERROR_MESSAGE k)
{
  grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
  grovalFunc.println((TC[]){L"󥿥२顼"});
  switch (k){
  case FUNC_NODEFINE:
    grovalFunc.println((TC[]){L"ؿ"});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"䤬ޤ"});
    break;
  }
  CError err;
}

void CMessage::error_mes(TC *str, ERROR_MESSAGE k)
{
  grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
  grovalFunc.println((TC[]){L"顼"});
  switch (k){
  case FUNC_REDEFINE:
    grovalFunc.println((TC[]){L"ؿ"});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"ϤǤƤޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  case FUNC_DEFINE:
    grovalFunc.println((TC[]){L""});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"ϤǤ˴ؿȤƤޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  case VAR_DEFINE:
    grovalFunc.println((TC[]){L""});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"ϤǤѿȤƤޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  case SYNTAX:
    grovalFunc.println((TC[]){L"ʸˡäƤޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  case NODEFINE:
    grovalFunc.println((TC[]){L""});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"䤬Ƥޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  case FUNC_NODEFINE:
    grovalFunc.println((TC[]){L"ؿ"});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"䤬Ƥޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  case VAR_NODEFINE:
    grovalFunc.println((TC[]){L"ѿ"});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"䤬Ƥޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  }
  error_num++;
  CError err;
}

void CMessage::warning_mes(TC *str, ERROR_MESSAGE k)
{
  grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
  grovalFunc.println((TC[]){L"ף硪"});
  switch (k){
  case VAR_REDEFINE:
    grovalFunc.println((TC[]){L"ѿ"});
    grovalFunc.println(str);
    grovalFunc.println((TC[]){L"ϤǤƤޤ"});
    this->def_mes((TC*)NULL, (VARKIND)-1);
    break;
  }
  warning_num++;
}

void CMessage::def_mes(TC *str, VARKIND k)
{
  static VARKIND kind = (VARKIND)-1;
	
  if (k == VOBJ){
    grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
    grovalFunc.println((TC[]){L"ȡ"});
  }
  else if (k != kind){
    if(k == VAR){
      grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
      grovalFunc.println((TC[]){L"ѡ"});
    }
    else if(k == FUNC){
      grovalFunc.println((TC[]){TK_BSLH, TK_n, 0});
      grovalFunc.println((TC[]){L"ء"});
    }
  }
  kind = k;
  if(str != NULL){
    grovalFunc.println(str);
  }
  grovalFunc.println((TC[]){L""});
}

void CMessage::opening()
{
  grovalFunc.cls();
  grovalFunc.println((TC[]){L"ӣá¡ݣ֡ң" | TK_BSLH, TK_n, 0 });
  grovalFunc.println((TC[]){L"ãʣáˡ١ˣ" | TK_BSLH, TK_n, 0 });
  grovalFunc.println((TC[]){L"ãʣáˡԡ٣" | TK_BSLH, TK_n, 0 });
  error_num = 0;
  warning_num = 0;
}

void CMessage::ending()
{
  grovalFunc.println((TC[]){TK_BSLH, TK_n, TK_BSLH, TK_n, 0});
  if ((error_num == 0) && (warning_num == 0)){
    grovalFunc.println((TC[]){L"ã塡塥"});
  }
  else {
    grovalFunc.println((TC[]){L"ţ򡡡"});
    grovalFunc.println(error_num);
    grovalFunc.println((TC[]){L"ף硡"});
    grovalFunc.println(warning_num);
  }
  grovalFunc.println((TC[]){TK_BSLH, TK_n, TK_BSLH, TK_n, 0});
}


