#ifndef _MESSAGE_H
#define _MESSAGE_H

#include <basic.h>
#include "gcommon.h"

typedef enum {
  VAR_REDEFINE, FUNC_REDEFINE, VAR_DEFINE, FUNC_DEFINE,
  SYNTAX, VAR_NODEFINE, FUNC_NODEFINE, NODEFINE
} ERROR_MESSAGE;

class CMessage
{
private:
  int error_num, warning_num;
	
public:
  CMessage() {
    error_num = 0;
    warning_num = 0;
  } 
  ~CMessage() {}
	
  void def_mes(TC *str, VARKIND k);
  void warning_mes(TC *str, ERROR_MESSAGE k);
  void error_mes(TC *str, ERROR_MESSAGE k);
  void runtime_mes(TC *str, ERROR_MESSAGE k);
  void opening();
  void ending();
};

#endif	// end of message.h

