#include <basic.h>
#include <btron/hmi.h>
#include <btron/message.h>
#include <btron/vobj.h>
#include <btron/proctask.h>
#include <btron/file.h>
#include <new>
#include "subc.h"
#include "ktext.h"
#include "textscr.h"
#include "record.h"
#include "compiler.h"
#include "getkey.h"

#include "kim_data.h"
#include "kdither.h"
#include "kpalet.h"

void killme();
void redisp();
void selectmenu(W i);
void popupmenu();
static void butdn();

W wid0 = -1;
W mid0 = -1;
static WEVENT	wev0;
static W vid0 = -1;

static TC mlist0[] = {MC_STR|MC_KEY1, L"Žλ"};
static TC mlist1[] = {MC_STR, L"Ƽ¹"};
static TC mlist2[] = {MC_STR, L"ƥѥ"};

#define MENU_WINDOW  3

static MENUITEM mitem[MENU_WINDOW+2] = {
  {0L, 0L, 0, 0, mlist0},
  {0L, 0L, 0, 0, mlist1},
  {0L, 0L, 0, 0, mlist2},
  {0L, 0L, 0, 0, NULL},
  {0L, 0L, 0, 0, NULL}
};

void OutSider::locate(int x, int y)
{
  if (ts == NULL){
    return;
  }
  ts->locate(x, y);
}

void OutSider::cls()
{
  if (ts == NULL){
    return;
  }
  ts->cls();
}

void OutSider::line_cls(int n)
{
  if (ts == NULL){
    return;
  }
  ts->line_cls(n);
}

int OutSider::get_curX()
{
  if (ts == NULL){
    return -1;
  }
  return (ts->get_curX());
}

int OutSider::get_curY()
{
  if (ts == NULL){
    return -1;
  }
  return (ts->get_curY());
}

void OutSider::println(TC *str)
{
  if (ts == NULL){
    return;
  }
  ts->println(str);
}

void OutSider::println(int d)
{
  if (ts == NULL){
    return;
  }
  ts->println(d);
}

TC OutSider::getkey()
{
  if (gk == NULL){
    return TNULL;
  }
  return gk->get_key();
}

void OutSider::flushkey()
{
  if (gk == NULL){
    return;
  }
  gk->flush_key();
}


OutSider grovalFunc;
TextScreen *disp;
SubC *comp;
GetKey *key;

//static baseaddr = 0;

void killme()
{
  gset_ptr(PS_BUSY, NULL, -1L, -1L);
  if(mid0 > 0){
    mdel_men(mid0);
  }
  if(vid0 > 0){
    oend_prc(vid0, NULL, 0);
  }
  if(wid0 > 0){
    wcls_wnd(wid0, CLR);
  }
  ext_prc(0);
}

void redisp()
{
  do {
    RECT rect;
    if (wsta_dsp(wid0, &rect, NULL) == 0){
      break;
    }
    disp->redisplay(rect.c.left, rect.c.top, rect.c.right, rect.c.bottom);
  } while(wend_dsp(wid0) > 0);
  return;
}

void selectmenu(W i)
{
  switch(i >> 8){
  case 0:
    killme();
    break;
  case 1:
    comp->execute();
    break;
  case 2:
    comp->set_cpl();
    comp->compile();
    break;
  case MENU_WINDOW:
    wexe_dmn(i);
    break;
  case MENU_WINDOW+1:
    oexe_apg(0, i);
    break;
  }
  return;
}

void popupmenu()
{
  W i;
	
  wget_dmn(&(mitem[MENU_WINDOW].ptr));
  mset_itm(mid0, MENU_WINDOW, mitem+MENU_WINDOW);
	
  oget_men(0, NULL, &(mitem[MENU_WINDOW+1].ptr), NULL, NULL);
  mset_itm(mid0, MENU_WINDOW+1, mitem+MENU_WINDOW+1);
	
  gset_ptr(PS_SELECT, NULL, -1L, -1L);
  i = msel_men(mid0, wev0.s.pos);
  if (i > 0){
    selectmenu(i);
  }
  return;
}

static void butdn()
{
  W i;
  switch (wev0.s.cmd){
  case W_PICT:
    switch (wchk_dck(wev0.s.time)){
    case W_DCLICK:
      killme();
      break;
    case W_PRESS:
      break;
    default:
      return;
    }
  case W_FRAM:
  case W_TITL:
    if (wmov_drg(&wev0, NULL) > 0){
      redisp();
    }
    return;
  }
  return;
}

extern "C" W MAIN(MESSAGE* msg)
{
  static RECT r0 = {20, 20, 20+WINDOW_SIZE_H+7, 20+WINDOW_SIZE_V+30};
	
  static TC tit0[21];
  W err;
  
  err = dopn_dat(NULL);
	
  if (err < 0){
    pdsp_msg((TC[]){L"ƥǡܥåץǤޤ"});
    sig_buz(0);
    killme();
  }
  switch (((M_EXECREQ*)msg)->type){
  case EXECREQ:
    if ((((M_EXECREQ*)msg)->mode & 2) == 0){
      break;
    }
    break;
  case DISPREQ:
    oend_req(((M_DISPREQ*)msg)->vid, -1);
    killme();
    break;
  case PASTEREQ:
    oend_req(((M_PASTEREQ*)msg)->vid, -1);
    killme();
    break;
  default:
    pdsp_msg((TC[]){L"Ȥ餷¹ԤǤޤ"});
    sig_buz(0);
    killme();
    break;
  }
	
  chg_wrk(NULL);
  fil_sts(&(((M_EXECREQ*)msg)->lnk), tit0, NULL, NULL);
  vid0 = ((M_EXECREQ*)msg)->vid;
  mid0 = mcre_men(MENU_WINDOW+2, mitem, NULL);
  if (mid0 < 0){
    pdsp_msg((TC[]){L"˥塼ϿǤޤ"});
    sig_buz(0);
    killme();
  }
  PAT pg;
  pg.spat.fgcol = 2;
  pg.spat.bgcol = 15;
	
  wid0 = wopn_wnd(0, ((M_EXECREQ*)msg)->pwid, &r0, &(((M_EXECREQ*)msg)->r), 2, tit0, &pg, NULL);
	
  if (wid0 < 0){
    pdsp_msg((TC[]){L"ɥץǤޤ"});
    sig_buz(0);
    killme();
  }
  osta_prc(vid0, wid0);
//	gid0 = wget_gid(wid0);
  disp = new(std::nothrow) TextScreen(wid0);
  grovalFunc.set_TextScreen(disp);
	
//	wreq_dsp(wid0);
	
//	if(readdata(&(msg->lnk)) < 0){
//		pdsp_msg((TCODE *)L" ¿Ȥɤ߹ߤ˼Ԥޤ");
//		sig_buz(0);
//		killme();
//	}
	
  comp = new(std::nothrow) SubC(&(((M_EXECREQ*)msg)->lnk));
  key = new(std::nothrow) GetKey();
  grovalFunc.set_GetKey(key);

  comp->compile();
  comp->execute();
	
  for (;;){
    eventloop();
  }

  return -1; // -- Not Reached
}


void eventloop()
{
  //WORD msg0[32];
  MESSAGE msg0;

//	while(1){
  wget_evt(&wev0, NOWAIT);
  switch (wev0.s.type){
  case EV_NOMSG:	
    break;
  case EV_NULL:
    if (wev0.s.wid != wid0){
      break;
    }
    if (wev0.s.cmd != W_WORK){
      break;
    }
    if (wev0.s.stat & ES_CMD){
      break;
    }
    gset_ptr(PS_SELECT, NULL, -1L, -1L);
    break;
  case EV_REQUEST:
    switch(wev0.g.cmd){
    case W_REDISP:
      redisp();
      break;
    case W_PASTE:
      wrsp_evt(&wev0, 1);
      break;
    case W_DELETE:
    case W_FINISH:
      wrsp_evt(&wev0, 0);
      killme();
    }
    break;
  case EV_RSWITCH:
    redisp();
    break;
  case EV_SWITCH:
  case EV_BUTDWN:
    butdn();
    break;
  case EV_INACT:
    break;
  case EV_DEVICE:
    oprc_dev(&(wev0.e), NULL, 0);
    break;
  case EV_MSG:
    //rcv_msg(0x7fffffffL, (MESSAGE *)msg0, sizeof(msg0), NOWAIT|CLR);
    rcv_msg(0x7fffffff, &msg0, sizeof(MESSAGE), NOWAIT|CLR);
    break;
  case EV_MENU:
    popupmenu();
    break;
  case EV_KEYDWN:
    if (wev0.s.stat & ES_CMD){
      W i = mfnd_key(mid0, wev0.s.wid);
      if (i > 0){
        selectmenu(i);
      }
      break;
    }
    key->put_key(wev0.s.wid);
    break;
  }
//	}
}

