#ifndef	_VIRTUAL_OBJECT_H
#define	_VIRTUAL_OBJECT_H

#include <basic.h>

class VirtualObject
{
  VirtualObject *next;
  LINK lnk_rec;
	
public:
  VirtualObject(LINK *data, VirtualObject *p) {
    memcpy(&lnk_rec, data, sizeof(LINK));
    next = p;
  }

  ~VirtualObject() {}

  VirtualObject *getNext() {
    return next;
  }

  void setNext(VirtualObject *p) {
    next = p;
  }

  LINK* getVirtualObject() {
    return &lnk_rec;
  }
};


class VirtualObjectList
{
  VirtualObject *pEnd;
  VirtualObject *pStart;
  VirtualObject *pCursor;
  int objNum;
	
public:
  VirtualObjectList();
  ~VirtualObjectList() {
    deleteAll();
  }
  int setObject(LINK *data);
  int getObjecctNum(void) {
    return objNum;
  }
  void seekTop() {
    pCursor = pStart;
  }
  VirtualObject* getVirtualObject();
  void deleteAll();
};

#endif		//	end of vobj.h

