#ifndef	_K_DITHER
#define	_K_DITHER

#include "kim_data.h"
#include "kpixel.h"
#include "kpalet.h"
// #include "kbitmap.h"

class KDither
{
  KPallet *colorPallet;
	
public:
  KDither(KPallet *pl);

  ~KDither() {
    delete colorPallet;
  } 
	
  unsigned char *calc_ditherFloyd(unsigned char *dst, KImageData *src);

protected:
  int getNearYPbPr(KYPbPr &d);
};

#endif		// end of kdither.h
