#include <basic.h>
#include "kpixel.h"

// class KPixel abstract class functions
/*
void KPixel::prt_data(void)
{
	KRGB 	d1 = get_RGB();
	KYPbPr	d2 = get_YPbPr();
	
//	cout << "R : " << d1.RR << "\t"
//		 << "G : " << d1.GG << "\t"
//		 << "B : " << d1.BB << endl;
	
//	cout << "Y : "  << d2.YY << "\t"
//		 << "Pb : " << d2.Pb << "\t"
//		 << "Pr : " << d2.Pr << endl;
}
*/

// class KRGB class functions

KYPbPr KRGB::get_YPbPr()
{
  KYPbPr d;
	
  d.YY = (21 * RR) / 100 + (72 * GG) / 100 + (7 * BB) / 100;
  d.Pb = 54 * (BB - d.YY) / 100;
  d.Pr = 63 * (RR - d.YY) / 100;
	
//	d.YY = 0.2125 * RR + 0.7154 * GG + 0.0721 * BB;
//	d.Pb = 0.5389 * (BB - d.YY);
//	d.Pr = 0.6349 * (RR - d.YY);
	
  return d;
}


// class KYPbPr class functions

KRGB KYPbPr::get_RGB()
{
  KRGB d;

//	double pb = (Pb / 0.5389);
//	double pr = (Pr / 0.6349);
  int pb = (Pb * 100 / 54);
  int pr = (Pr * 100 / 63);
		
//	d.RR = YY + pr;
//	d.GG = YY - 0.1008 * pb - 0.2970 * pr;
//	d.BB = YY + pb;
	
  d.RR = YY + pr;
  d.GG = YY - (10 * pb) / 100 - (30 * pr) / 100;
  d.BB = YY + pb;
	
  return d;
}


/*
void main(void)
{
	KRGB rgb;
	KYPbPr yp;
	
	rgb.RR = 123;
	rgb.GG = 201;
	rgb.BB = 23;
	
	rgb.prt_data();
	
	yp = rgb.get_YPbPr();
	yp.prt_data();
}
*/
