#ifndef	_KTEXT_H
#define	_KTEXT_H

#include <basic.h>
#include <tstring.h>

class KTextLine
{
  KTextLine *next;
  TC *lineData;
	
public:
  KTextLine(TC *str, KTextLine *p);
  ~KTextLine() {
    // b_printf("KTextLine::delete\n");
    delete[] lineData;
  }
  KTextLine* getNext() {
    return next;
  }
  void setNext(KTextLine *p) {
    next = p;
  }
  TC *getTextLine() {
    return lineData;
  }
  int setTextLine(TC* str);
  int getTextLineLen() {
    return tc_strlen(lineData);
  }
};


class KText
{
  KTextLine *pEnd;
  KTextLine *pStart;
  int lineNum;
  KTextLine *pCursor;
	
public:
  KText();
  ~KText() {
    deleteAll();
  }
  int setLine(TC* str);
  int getLineNum() {
    return lineNum;
  }
  void seekTop() {
    pCursor = pStart;
  }
  int getTextLine(TC*& str);
  void deleteAll();
	
};


#endif		//	end of ktext.h
